/* state.c generated by valac 0.38.7, the Vala compiler
 * generated from state.vala, do not modify */

/*   FILE: state.vala -- A state machine implementing lcdgrilo's menu
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 01 December 2013 
 *
 * Copyright (c) 2013 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>


#define TYPE_STATE (state_get_type ())
#define STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE, State))
#define STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE, StateClass))
#define IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE))
#define IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE))
#define STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE, StateClass))

typedef struct _State State;
typedef struct _StateClass StateClass;
typedef struct _StatePrivate StatePrivate;

#define TYPE_LCD_PLAYER (lcd_player_get_type ())
#define LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LCD_PLAYER, LCDPlayer))
#define LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LCD_PLAYER, LCDPlayerClass))
#define IS_LCD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LCD_PLAYER))
#define IS_LCD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LCD_PLAYER))
#define LCD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LCD_PLAYER, LCDPlayerClass))

typedef struct _LCDPlayer LCDPlayer;
typedef struct _LCDPlayerClass LCDPlayerClass;
enum  {
	STATE_0_PROPERTY,
	STATE_NUM_PROPERTIES
};
static GParamSpec* state_properties[STATE_NUM_PROPERTIES];

#define TYPE_STACK (stack_get_type ())
#define STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STACK, Stack))
#define STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STACK, StackClass))
#define IS_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STACK))
#define IS_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STACK))
#define STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STACK, StackClass))

typedef struct _Stack Stack;
typedef struct _StackClass StackClass;

#define TYPE_STATE_PLAY (state_play_get_type ())
#define STATE_PLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATE_PLAY, StatePlay))
#define STATE_PLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATE_PLAY, StatePlayClass))
#define IS_STATE_PLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATE_PLAY))
#define IS_STATE_PLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATE_PLAY))
#define STATE_PLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATE_PLAY, StatePlayClass))

typedef struct _StatePlay StatePlay;
typedef struct _StatePlayClass StatePlayClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _State {
	GObject parent_instance;
	StatePrivate * priv;
	LCDPlayer* player;
};

struct _StateClass {
	GObjectClass parent_class;
	void (*print_selected) (State* self);
	void (*seekback) (State* self);
	void (*seekforward) (State* self);
	void (*next) (State* self);
	void (*previous) (State* self);
	State* (*transition) (State* self);
};


static gpointer state_parent_class = NULL;

GType state_get_type (void) G_GNUC_CONST;
gpointer lcd_player_ref (gpointer instance);
void lcd_player_unref (gpointer instance);
GParamSpec* param_spec_lcd_player (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_lcd_player (GValue* value, gpointer v_object);
void value_take_lcd_player (GValue* value, gpointer v_object);
gpointer value_get_lcd_player (const GValue* value);
GType lcd_player_get_type (void) G_GNUC_CONST;
void state_print_selected (State* self);
static void state_real_print_selected (State* self);
void state_stop (State* self);
GType stack_get_type (void) G_GNUC_CONST;
Stack* lcd_player_get_stateStack (LCDPlayer* self);
gpointer stack_peek (Stack* self);
GType state_play_get_type (void) G_GNUC_CONST;
gpointer stack_pop (Stack* self);
void lcd_player_stop (LCDPlayer* self);
void state_pauseplay (State* self);
void lcd_player_pauseplay (LCDPlayer* self);
void state_seekback (State* self);
static void state_real_seekback (State* self);
void state_seekforward (State* self);
static void state_real_seekforward (State* self);
void state_next (State* self);
static void state_real_next (State* self);
void state_previous (State* self);
static void state_real_previous (State* self);
State* state_transition (State* self);
static State* state_real_transition (State* self);
State* state_construct (GType object_type);
static void state_finalize (GObject * obj);


static void state_real_print_selected (State* self) {
	g_critical ("Type `%s' does not implement abstract method `state_print_selected'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void state_print_selected (State* self) {
	g_return_if_fail (self != NULL);
	STATE_GET_CLASS (self)->print_selected (self);
}


void state_stop (State* self) {
	LCDPlayer* _tmp0_;
	Stack* _tmp1_;
	Stack* _tmp2_;
	gpointer _tmp3_;
	State* _tmp4_;
	gboolean _tmp5_;
	LCDPlayer* _tmp11_;
	LCDPlayer* _tmp12_;
	Stack* _tmp13_;
	Stack* _tmp14_;
	gpointer _tmp15_;
	State* _tmp16_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	_tmp1_ = lcd_player_get_stateStack (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = stack_peek (_tmp2_);
	_tmp4_ = (State*) _tmp3_;
	_tmp5_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, TYPE_STATE_PLAY);
	_g_object_unref0 (_tmp4_);
	if (_tmp5_) {
		LCDPlayer* _tmp6_;
		Stack* _tmp7_;
		Stack* _tmp8_;
		gpointer _tmp9_;
		State* _tmp10_;
		_tmp6_ = self->player;
		_tmp7_ = lcd_player_get_stateStack (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = stack_pop (_tmp8_);
		_tmp10_ = (State*) _tmp9_;
		_g_object_unref0 (_tmp10_);
	}
	_tmp11_ = self->player;
	lcd_player_stop (_tmp11_);
	_tmp12_ = self->player;
	_tmp13_ = lcd_player_get_stateStack (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = stack_peek (_tmp14_);
	_tmp16_ = (State*) _tmp15_;
	state_print_selected (_tmp16_);
	_g_object_unref0 (_tmp16_);
}


void state_pauseplay (State* self) {
	LCDPlayer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	lcd_player_pauseplay (_tmp0_);
}


static void state_real_seekback (State* self) {
	g_critical ("Type `%s' does not implement abstract method `state_seekback'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void state_seekback (State* self) {
	g_return_if_fail (self != NULL);
	STATE_GET_CLASS (self)->seekback (self);
}


static void state_real_seekforward (State* self) {
	g_critical ("Type `%s' does not implement abstract method `state_seekforward'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void state_seekforward (State* self) {
	g_return_if_fail (self != NULL);
	STATE_GET_CLASS (self)->seekforward (self);
}


static void state_real_next (State* self) {
	g_critical ("Type `%s' does not implement abstract method `state_next'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void state_next (State* self) {
	g_return_if_fail (self != NULL);
	STATE_GET_CLASS (self)->next (self);
}


static void state_real_previous (State* self) {
	g_critical ("Type `%s' does not implement abstract method `state_previous'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void state_previous (State* self) {
	g_return_if_fail (self != NULL);
	STATE_GET_CLASS (self)->previous (self);
}


static State* state_real_transition (State* self) {
	g_critical ("Type `%s' does not implement abstract method `state_transition'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


State* state_transition (State* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return STATE_GET_CLASS (self)->transition (self);
}


State* state_construct (GType object_type) {
	State * self = NULL;
	self = (State*) g_object_new (object_type, NULL);
	return self;
}


static void state_class_init (StateClass * klass) {
	state_parent_class = g_type_class_peek_parent (klass);
	((StateClass *) klass)->print_selected = (void (*) (State *)) state_real_print_selected;
	((StateClass *) klass)->seekback = (void (*) (State *)) state_real_seekback;
	((StateClass *) klass)->seekforward = (void (*) (State *)) state_real_seekforward;
	((StateClass *) klass)->next = (void (*) (State *)) state_real_next;
	((StateClass *) klass)->previous = (void (*) (State *)) state_real_previous;
	((StateClass *) klass)->transition = (State* (*) (State *)) state_real_transition;
	G_OBJECT_CLASS (klass)->finalize = state_finalize;
}


static void state_instance_init (State * self) {
}


static void state_finalize (GObject * obj) {
	State * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATE, State);
	G_OBJECT_CLASS (state_parent_class)->finalize (obj);
}


GType state_get_type (void) {
	static volatile gsize state_type_id__volatile = 0;
	if (g_once_init_enter (&state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (State), 0, (GInstanceInitFunc) state_instance_init, NULL };
		GType state_type_id;
		state_type_id = g_type_register_static (G_TYPE_OBJECT, "State", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&state_type_id__volatile, state_type_id);
	}
	return state_type_id__volatile;
}



